<?php

namespace Teknisa\DF\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\DF\Factories\Ger00300EncargoFactory;

class Ger00300EncargoService {

    public function __construct($entityManager, $environment, Ger00300EncargoFactory $ger00300EncargoFactory) {
        $this->environment = $environment;
        $this->nrorg = $this->environment->getNrOrgTrab();
        $this->entityManager = $entityManager;
        $this->ger00300EncargoFactory = $ger00300EncargoFactory;
    }
    
    public function saveEncargo($row){
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        try{
            if ($row['__is_new']){
                $existeEncargo = $this->ger00300EncargoFactory->getEncargo($row['CDENCARGO'], $this->nrorg);
                if ($existeEncargo)
                    throw new \Exception('Registro já cadastrado.');
                $row['CDENCARGONFE'] = (array_key_exists('CDENCARGONFE', $row)) ? $row['CDENCARGONFE'] : null;
                $encargonfe = $this->ger00300EncargoFactory->getEncargonfe($row['CDENCARGONFE'], $this->nrorg);
                if (!$encargonfe && $row['CDENCARGONFE']){
                    $encargonfe = $this->ger00300EncargoFactory->insereEncargonfe($row, $this->nrorg);
                    $this->entityManager->persist($encargonfe);
                    $this->entityManager->flush();
                }
                $encargo = $this->ger00300EncargoFactory->insereEncargo($row, $this->nrorg);
                $this->entityManager->persist($encargo);
            }else{
                $encargonfe = $this->ger00300EncargoFactory->getEncargonfe($row['CDENCARGONFE'], $this->nrorg);

                if (!$encargonfe && $row['CDENCARGONFE']){
                    $encargonfe = $this->ger00300EncargoFactory->insereEncargonfe($row, $this->nrorg);
                    $this->entityManager->persist($encargonfe);
                    $this->entityManager->flush();
                }
                $encargo = $this->ger00300EncargoFactory->updateEncargo($row, $this->nrorg);
                $this->entityManager->persist($encargo);
            }
            $this->entityManager->flush();
            $connection->commit();
        }catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
}